def ithil_facefinder
	model = Sketchup.active_model
	selection = model.selection
	selection = model.active_entities if selection.empty?
	model.start_operation ("FaceFinder")
	process_at_level_finder selection, {}
	model.commit_operation
end

def process_at_level_finder(entities, hcomp)
	entities.each do |entity| 
		case entity.typename
		when 'Group'
			process_at_level_finder entity.entities, hcomp
		when 'ComponentInstance'
			edef = entity.definition
			next if hcomp[edef.to_s]
			hcomp[edef.to_s] = edef
			process_at_level_finder edef.entities, hcomp
		when 'Edge'
			entity.find_faces
		end
	end
end	

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("FaceFinder") { ithil_facefinder }
	end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item("FaceFinder") { ithil_facefinder }
	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)
