def ithil_reverseface
	model = Sketchup.active_model
	selection = model.selection
	selection = model.active_entities if selection.empty?
	model.start_operation ("Reverse Face All")
	process_at_level_revers selection, {}
	model.commit_operation
end

def process_at_level_revers(entities, hcomp)
	entities.each do |entity| 
		case entity.typename
		when 'Group'
			process_at_level_revers entity.entities, hcomp
		when 'ComponentInstance'
			edef = entity.definition
			next if hcomp[edef.to_s]
			hcomp[edef.to_s] = edef
			process_at_level_revers edef.entities, hcomp
		when 'Face'
			entity.reverse!
		end
	end
end	

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Reverse Face All") { ithil_reverseface }
	end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item("Reverse Face All") { ithil_reverseface }
	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)
